extends Node2D


const ENEMY = preload("res://Scenes/EnemyShip.tscn")
const BOSS = preload("res://Scenes/Boss.tscn")

var inverted = false


# Ready ========================================================================
func _ready():
	pass


# Process ======================================================================
func _process(delta):
	pass


# Actions ======================================================================

# Invert -----------------------------------------------------------------------
func invert(is_inverted):
	inverted = is_inverted


# Create enemy -----------------------------------------------------------------
func create_enemy(type, pattern, position):
	var enemy = ENEMY.instance()
	enemy.invert(inverted)
	enemy.set_type(type)
	enemy.set_pattern(pattern)
	add_child(enemy)
	enemy.global_position.x = position.x
	enemy.global_position.y = position.y


# Create boss ------------------------------------------------------------------
func create_boss():
	var boss = BOSS.instance()
	boss.invert(inverted)
	add_child(boss)
	boss.global_position.x = 480
	boss.global_position.y = -128


# Stages =======================================================================

# 1 - It Is Easy ---------------------------------------------------------------
func stage_it_is_easy():
	create_enemy(EnemyType.LIZARD, EnemyPattern.FREE_FALL, Vector2(249, -50))
	create_enemy(EnemyType.LIZARD, EnemyPattern.FREE_FALL, Vector2(480, -270))
	create_enemy(EnemyType.LIZARD, EnemyPattern.FREE_FALL, Vector2(711, -540))
	
func stage_it_is_showtime():
	create_enemy(EnemyType.CROCODILE, EnemyPattern.HURRICANE, Vector2(249, -50))
	create_enemy(EnemyType.CROCODILE, EnemyPattern.HURRICANE, Vector2(480, -270))
	create_enemy(EnemyType.CROCODILE, EnemyPattern.HURRICANE, Vector2(711, -540))

func stage_it_is_twister():
	create_enemy(EnemyType.KOMODO, EnemyPattern.TWISTER, Vector2(249, -270))
	create_enemy(EnemyType.KOMODO, EnemyPattern.TWISTER, Vector2(480, -50))
	create_enemy(EnemyType.KOMODO, EnemyPattern.TWISTER, Vector2(711, -270))

func stage_boss_fight():
	create_boss()
