extends TextureProgress

enum STATE {
	WAITING,
	UPDATING,
	RESETING,
}

var real_max = 10
var real_value = 10
var animated_value = 10

var rounded_value = 0
var speed = 1
var state = STATE.WAITING


# Ready =======================================================================
func _ready():
	pass 


# Process =====================================================================
func _process(delta):
	
	if state == STATE.RESETING:
		if value < max_value:
			rounded_value += delta * max_value
			value = int(rounded_value)
		else:
			state = STATE.WAITING
	
	if state == STATE.UPDATING:
		if value != animated_value:
			rounded_value += (delta * max_value * speed) * (1 if value < animated_value else -1)
			value = int(rounded_value)
		else:
			state = STATE.WAITING


# Actions =====================================================================


# Update value ----------------------------------------------------------------
func update_value(new_value, animated=false, new_speed=1):
	new_value = new_value if new_value > 0 else 0
	real_value = new_value
	animated_value = int((real_value * max_value) / real_max)
	speed = new_speed
	if animated:
		state = STATE.UPDATING
		rounded_value = value
	else:
		value = int((real_value * max_value) / real_max)


# Reset Value -----------------------------------------------------------------
func reset(new_max_value):
	print("chamou o reset")
	value = 0
	rounded_value = 0
	real_max = new_max_value
	state = STATE.RESETING