extends CanvasLayer


var on_main_menu = true
var on_animation = false
var on_credits = false
var on_dead_menu = false


# Ready ========================================================================
func _ready():
	$Menu/VBoxContainer/ButtonPlay.grab_focus()


# Process ======================================================================
func _process(delta):
	
	if on_credits:
		if Input.is_action_just_pressed("ui_cancel"):
			close_credits()


# Action =======================================================================

# Play -------------------------------------------------------------------------
func play_game():
	if on_main_menu and not on_animation:
		if on_credits:
			close_credits()
		on_main_menu = false
		$Animation.play("Leave")
		get_parent().set_act()


# Credits ---------------------------------------------------------------------
func open_credits():
	if on_main_menu and not on_animation and not on_credits:
		on_credits = true
		on_animation = true
		$Credits/Animation.play("Show")
		yield(get_tree().create_timer(0.5), 'timeout')
		on_animation = false

func close_credits():
	on_animation = true
	$Credits/Animation.play("Hide")
	yield(get_tree().create_timer(0.5), 'timeout')
	on_animation = false
	on_credits = false


# Options ----------------------------------------------------------------------
func options():
	if on_main_menu and not on_animation:
		pass


# Quit -------------------------------------------------------------------------
func quit():
	if on_main_menu and not on_animation:
		get_tree().quit()


# Retry ------------------------------------------------------------------------
func retry():
	if on_dead_menu:
		on_dead_menu = false
		$DeadMenu/Animation.play("Leave")
		get_parent().retry()


# Give up ----------------------------------------------------------------------
func give_up():
	if on_dead_menu:
		on_dead_menu = false
		$DeadMenu/Animation.play("Leave")
		get_parent().give_up()


# Enter main menu --------------------------------------------------------------
func enter():
	if not on_main_menu:
		$Menu/VBoxContainer/ButtonPlay.grab_focus()
		$Animation.play("Enter")
		on_animation = true
		on_main_menu = true
		yield(get_tree().create_timer(0.5), 'timeout')
		on_animation = false
		

# Leave main menu --------------------------------------------------------------
func leave():
	if on_main_menu:
		on_animation = true
		$Animation.play("Leave")
		yield(get_tree().create_timer(0.5), 'timeout')
		on_animation = false


# Enter dead menu --------------------------------------------------------------
func enter_dead_menu():
	if not on_dead_menu:
		on_dead_menu = true
		$DeadMenu/VBoxContainer/ButtonRetry.grab_focus()
		$DeadMenu/Animation.play("Enter")


# Leave dead menu --------------------------------------------------------------
func leave_dead_menu():
	if on_dead_menu:
		on_dead_menu = false
		$DeadMenu/Animation.play("Leave")


# Signasl ======================================================================

# Main menu buttons ------------------------------------------------------------

func _on_ButtonPlay_pressed():
	play_game()

func _on_ButtonCredits_pressed():
	open_credits()

func _on_ButtonOptions_pressed():
	options()

func _on_ButtonQuit_pressed():
	quit()

func _on_ButtonGiveUp_pressed():
	give_up()

func _on_ButtonRetry_pressed():
	retry()
