extends Node2D

const EXPLOSION = preload("res://Scenes/PlayerBulletExplosion.tscn")

export var direction = Vector2.ZERO
export var speed = 1400
var inverted = false


# Ready ========================================================================
func _ready():
	invert(inverted)


# Process ======================================================================
func _process(delta):
	translate(direction * speed * delta)


# Actions ======================================================================

# Invert -----------------------------------------------------------------------
func invert(is_inverted):
	inverted = is_inverted
	$Sprite.frame = 0 if inverted else 1


# Explode ----------------------------------------------------------------------
func explode():
	var explosion = EXPLOSION.instance()
	get_parent().add_child(explosion)
	explosion.global_position = global_position
	explosion.explode(inverted)
	queue_free()


# Signals ======================================================================

# Bullet exited ----------------------------------------------------------------
func _on_VisibilityNotifier_screen_exited():
	queue_free()

# Bullet hit a enemy ship ------------------------------------------------------
func _on_Area_area_entered(area):
	explode()
